export interface IStateTreeNode<C = any, S = any> {
    readonly $treenode?: any;
    readonly "!!types"?: [C, S] | [any, any];
}
export interface IAnyStateTreeNode extends IStateTreeNode<any, any> {
}
/**
 * Returns true if the given value is a node in a state tree.
 * More precisely, that is, if the value is an instance of a
 * `types.model`, `types.array` or `types.map`.
 *
 * @export
 * @param {*} value
 * @returns {value is IStateTreeNode}
 */
export declare function isStateTreeNode<C = any, S = any>(value: any): value is IStateTreeNode<C, S>;
