import { IType, OptionalProperty } from "../../internal";
export declare function frozen<C>(subType: IType<C, any, any>): IType<C, C, C>;
export declare function frozen<T>(defaultValue: T): IType<T | undefined | null, T, T> & OptionalProperty;
export declare function frozen<T>(): IType<T, T, T>;
/**
 * Returns if a given value represents a frozen type.
 *
 * @export
 * @template IT
 * @template T
 * @param {IT} type
 * @returns {type is IT}
 */
export declare function isFrozenType<IT extends IType<T | any, T, T>, T = any>(type: IT): type is IT;
